--- dovecot-1.0.rc2.orig/src/lib/var-expand.c	2006-04-12 10:39:32.000000000 +0300
+++ dovecot-1.0.rc2/src/lib/var-expand.c	2006-07-24 15:02:16.310158586 +0300
@@ -87,6 +87,34 @@
 	return binary_to_hex(digest, sizeof(digest));
 }
 
+static const char *m_str_dn(const char *str, struct var_expand_context *ctx __attr_unused__)
+{
+	#define RET_SIZE 256
+	string_t *ret = t_str_new(RET_SIZE);
+	unsigned int str_offset, ret_offset;
+	size_t str_length;
+
+	str_length = strlen(str);
+
+	ret_offset = 0;
+	for (str_offset = 0; (ret_offset < RET_SIZE) && (str_offset < str_length)
+			&& (str[str_offset] != '\0'); str_offset++) {
+		if (str[str_offset] != '.') {
+			str_append_c(ret, str[str_offset]);
+		} else {
+			if ((ret_offset + 4) < RET_SIZE) {
+				str_append(ret, ",dc=");
+				ret_offset += 3;
+			} else { /* would overflow */
+				i_warning("string truncated");
+			}
+		}
+		ret_offset++;
+	}
+
+	return str_free_without_data(&ret);
+}
+
 #define MAX_MODIFIER_COUNT 10
 static const struct var_expand_modifier modifiers[] = {
 	{ 'L', m_str_lcase },
@@ -96,6 +124,7 @@
 	{ 'R', m_str_reverse },
 	{ 'H', m_str_hash },
 	{ 'M', m_str_md5 },
+	{ 'D', m_str_dn },
 	{ '\0', NULL }
 };
 